<?php



// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * set Seerox Guten Blocks
 */
 function get_seerox_blocks() {
	return array(
		'srxgb-tabs' => array(
			'id' => 'srxgb/srxgb-tabs',
			'name' => __( 'Tabs Block' , 'srxgb'),
			'icon' => 'tabs.svg',
		),
		'gutensrxtestimonials' => array(
			'id' => 'srxgb/gutensrxtestimonials',
			'name' => __( 'Testimonials Block' , 'srxgb'),
			'icon' => 'testimonial.svg',
		),
		'srx-according' => array(
			'id' => 'srxgb/srx-according',
			'name' => __( 'Accordion Block' , 'srxgb'),
			'icon' => 'accordion.svg',
		),
		'srxgb-slider' => array(
			'id' => 'srxgb/srxgb-slider',
			'name' => __( 'Slider Block' , 'srxgb'),
			'icon' => 'slider.svg',
		),
		'srxgb-profile' => array(
			'id' => 'srxgb/srxgb-profile',
			'name' => __( 'Profile Block' , 'srxgb'),
			'icon' => 'profile.svg',
		),

	);
}

/**
 * Proper way to enqueue scripts and styles.
 */
function srxgb_script_register() {

	wp_enqueue_style('srxbg-css', plugins_url('css/srxgb-setting.css',__FILE__ ));
    wp_enqueue_script('srxbg-script', plugins_url('js/srxbg-setting.js',__FILE__ ));

}
add_action( 'admin_enqueue_scripts', 'srxgb_script_register' );




 function srxgb_block_toggle_status_action() {
		$block_type = filter_var($_POST['block'], FILTER_SANITIZE_STRING);
		$status = filter_var($_POST['status'], FILTER_SANITIZE_STRING);

		$disabled_blocks = get_disabled_blocks();

		// Add block name in disabled list
		if ( $status == "disable" ) {

			$disabled_blocks[] = $block_type;
			array_unique( $disabled_blocks );

		// Remove block from disabled list
		} else {

			$keys = array_keys( $disabled_blocks, $block_type );

			foreach( $keys as $key ) {
				unset( $disabled_blocks[ $key ] );
			}
		}

		set_disabled_blocks($disabled_blocks);

		die;
	}

 add_action( 'wp_ajax_srxgb_block_toggle_status_action',  'srxgb_block_toggle_status_action' );

/**
 * Register a Seerox Block menu page.
 */
function srxgb_setting_register_menu_page() {
    add_menu_page(
        __( 'Easy Blocks Pro', 'srxgb' ),
        __( 'Easy Blocks Pro', 'srxgb' ),
        'manage_options',
        'srxgb-setting',
        'srxgb_setting_page',
        '' ,
        6
    );
}
add_action( 'admin_menu', 'srxgb_setting_register_menu_page' );



function srxgb_setting_page(){
?>
<style type="text/css">
.srx-gb-trigger .switch {
  position: relative;
  display: inline-block;
  width: 60px;
  height: 34px;
}

.srx-gb-trigger .switch input {
  opacity: 0;
  width: 0;
  height: 0;
}

.srx-gb-trigger .slider {
  position: absolute;
  cursor: pointer;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  background-color: #ccc;
  -webkit-transition: .4s;
  transition: .4s;
  border-radius: 2em;
}

.srx-gb-trigger .slider:before {
  position: absolute;
  content: "";
  height: 26px;
  width: 26px;
  left: 4px;
  bottom: 4px;
  background-color: white;
  -webkit-transition: .4s;
  transition: .4s;
  border-radius: 2em;
}

input:checked + .slider {
  background-color: #0073aa;
  border-radius: 2em;
}

input:focus + .slider {
  box-shadow: 0 0 1px #0073aa;
}

input:checked + .slider:before {
  -webkit-transform: translateX(26px);
  -ms-transform: translateX(26px);
  transform: translateX(26px);

  border-radius: 2em;
}

</style>
<div style="display: flex;padding: 20px;border-radius: 5px;margin: 10px 10px;justify-content: center;align-content: center;">
<img src="<?=plugins_url()?>/easy-blocks-pro/assets/img/icon-128x128.png"/>
	<h2 style="margin-left: 30px;font-size: 3em;font-family: 'Century Gothic regular';margin-top: 50px;">Easy Blocks Pro</h2>
</div>
<center><i>&quot;A complete gutenberg suit that provides pure gutenberg blocks to enhance page builder user experience and flexibility&quot;</i></center>
<hr>

		<input type="hidden"
			id="srxgb-admin-ajax-url"
			value="<?php echo admin_url('admin-ajax').'.php'; ?>">
<style type="text/css">tr,td{padding: 10px !important;}</style>
		<table align="center">
		<?php
			foreach (get_seerox_blocks() as $key => $block) {
				$active = !in_array( $block['id'], get_disabled_blocks() );
		?>
				<tr>
					<?php if ( isset( $block['icon'] ) ): ?>
						<td>
							<img src="<?=plugins_url()?>/easy-blocks-pro/assets/img/<?php echo $block['icon']; ?>" width="42" height="42"/>
						</td>
					<?php endif; ?>
					<td>
						<?php echo __($block['name'], 'srxgb'); ?>
					</td>
					<td class="srx-gb-trigger">
						<label class="switch">
						<input type="checkbox"
							class="srxgb_status_toggle <?php if( $active ): ?> is-active<?php endif; ?>"
							data-block="<?php echo $block['id']; ?>"
							data-status="<?php echo ( $active ) ? 'disable' : 'enable'; ?>"
							data-invert-status="<?php echo ( !$active ) ? 'disable' : 'enable'; ?>"
							<?php echo ( $active ) ? __( 'checked', 'srxgb' ) : __( '', 'srxgb' ); ?>
								/>
						  <span class="slider"></span>
						</label>
						<tt id="srx_status_<?php echo str_replace('/', '', $block['id']); ?>"<?php echo ( !$active ) ? ' style="color: red;">disabled' : 'style="color: green;">enabled'; ?></tt>
					</td>
				</tr>
				<tr><td colspan="3"><hr></td></tr>
			<?php }	?>
		</table>
<?php
}

// filter seerox enable block
function get_srxgb_enable_blocks(){
	$blocks = array();
	$srx_disable_block = get_disabled_blocks();
	$srx_all_block = get_seerox_blocks();

	foreach ($srx_all_block as $key => $block) {
		 if(!in_array( $block['id'], $srx_disable_block )){
		 	$blocks[] = $block['id'];
		 }
	}
	return $blocks;
}

wp_enqueue_script( 'ebp-deactivate-block-js',
			 plugins_url('js/easy-blocks-deactivate.js',__FILE__ ) , 
			 array( 'wp-blocks' ), 
			 1.0, 
			 true );


		wp_localize_script(
			'ebp-deactivate-block-js',
			'ebp_deactivate_blocks',
			array(
				'deactivated_blocks' => get_disabled_blocks(),
			)
		);


// filter / mearge seerox enable block and core/blocks
function set_allowed_block_types($allowed_block_types,  $post){

	$srx_enable_block = get_srxgb_enable_blocks();

	$all_native_wp_blocks = get_all_native_wp_blocks();

	return array_merge($srx_enable_block, $all_native_wp_blocks);
}

// add_filter( 'allowed_block_types', 'set_allowed_block_types', 10, 2 );



 	function get_disabled_blocks() {
		$blocks = get_option('srx-blocks-status');
		if ( $blocks == "" ) {
			return array();
		}
		 return $blocks;
	}

	function set_disabled_blocks($blocks) {
		update_option('srx-blocks-status', $blocks);
	}


	function get_all_native_wp_blocks() {
		return array(
					 'core/audio',
					 'core/cover-image',
					 'core/gallery',
					 'core/heading',
					 'core/image',
					 'core/list',
					 'core/paragraph',
					 'core/quote',
					 'core/subhead',
					 'core/video',
					 'core/code',
					 'core/freeform',
					 'core/html',
					 'core/preformatted',
					 'core/pullquote',
					 'core/table',
					 'core/verse',
					 'core/button',
					 'core/columns',
					 'core/more',
					 'core/separator',
					 'core/text-columns',
					 'core/shortcode',
					 'core/categories',
					 'core/latest-posts',
					 'core/embed',
					 'core-embed/twitter',
					 'core-embed/youtube',
					 'core-embed/facebook',
					 'core-embed/instagram',
					 'core-embed/wordpress',
					 'core-embed/soundcloud',
					 'core-embed/spotify',
					 'core-embed/flickr',
					 'core-embed/vimeo',
					 'core-embed/animoto',
					 'core-embed/cloudup',
					 'core-embed/collegehumor',
					 'core-embed/dailymotion',
					 'core-embed/funnyordie',
					 'core-embed/hulu',
					 'core-embed/imgur',
					 'core-embed/issuu',
					 'core-embed/kickstarter',
					 'core-embed/meetup-com',
					 'core-embed/mixcloud',
					 'core-embed/photobucket',
					 'core-embed/polldaddy',
					 'core-embed/reddit',
					 'core-embed/reverbnation',
					 'core-embed/screencast',
					 'core-embed/scribd',
					 'core-embed/slideshare',
					 'core-embed/smugMug',
					 'core-embed/speaker',
					 'core-embed/ted',
					 'core-embed/tumblr',
					 'core-embed/videopress',
					 'core-embed/wordpress-tv',
				);
		}


